﻿//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Fcad416.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#define	MAX_BOARD	16
#define	PriTrigBufSize	65536
#define	X_START		0
#define	X_WIDTH		642
#define	Y_START		0
#define	Y_WIDTH		420
TForm1 *Form1;
int	samplingclockvalue;			// サンプリングクロック設定値
int	samplingnumber;				// サンプリングデータ数
int	scanclocknumber;			// スキャンクロック（数値）

int trg_mode, trg_source, trg_type, stop_mode, trig_level1, trig_level2;	// Fca416_Set_Trigger関数のパラメータ
int ringmode;
int	clk_source, set_mode, time_unit, clk_period, exclk_freq;	// Fca416_Set_Clock関数のパラメータ
int post_samp;													// Fca416_Start_Samp関数のパラメータ
DWORD post_sampled, pre_sampled, pre_position;					// 取得済みデータ数
int no_ch, scan_order[MAX_BOARD], range[MAX_BOARD];				// Fca416_Set_SampCh関数のパラメータ
int inp_mode, ad_code;											// Fca416_Set_InpMode関数のパラメータ
int multi;														// Fca416_Set_MultiScan関数のパラメータ
int	transfersize;												// Fca416_Set_TransferSize関数のパラメータ
int Scanclockvalue;												// Fca416_Set_ScanSpeed関数のパラメータ
int	Memory_size[MAX_BOARD];										// Fca416_Set_Memory関数のパラメータ
DWORD MessageRequest[MAX_BOARD];								// メッセージ要求保持レジスタ
int	OpenedBoard[MAX_BOARD];										// オープンしたボードを記録する変数
int	SelectedBoard;												// 選択されたボードのロータリースイッチ番号
int	TestCount = 0;												// 動作回数カウンター
int	InSamplingMode;												// サンプリング中かどうかを判定する変数
int	data_count;
WORD num_board , board_no[MAX_BOARD];
int Inp_mode;
int Ad_code;
int Transer_Size;
int Mem_Size;
int Ring_Mode;
int	Trigger_Source;
int	Trigger_Type;
int	Trigger_Mode;
int	Threshold2, Threshold1, PriTriggerBuffer, Channel_Number;
int	Input_Range, ScanSpeed;
int	scan_enable[MAX_BOARD];
int	ScanClockMode = 0;			// 周期モードをハードコード

int StopEnable = 0;             // ストップ機能は使用しない

WORD *disp_buffer;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
 Form1->Edit1->Text="64";			// サンプリングクロック
 Form1->Edit2->Text="4";
 Form1->Edit3->Text="";
 Form1->Edit4->Text="";
 Form1->Edit5->Text="1000";			// サンプリング数
 Form1->Edit6->Text="";
 Form1->Edit7->Text="32768";
 Form1->Edit8->Text="32767";
 Form1->Edit9->Text="150";
 Form1->Edit10->Text="100";
 Form1->Edit11->Text="";
 Form1->Edit12->Text="";
 Form1->Edit13->Text="";
 Form1->Edit14->Text="";
 Form1->Edit15->Text="15";
 Form1->Edit16->Text="";
 Form1->Edit17->Text="";
 Form1->Edit18->Text="";
 Form1->Edit19->Text="";
 Form1->ComboBox1->ItemIndex=0;		// スキャンクロックは内部２０ＭＨｚ

 Form1->ComboBox2->ItemIndex=2;		// スキャンクロックの単位はμＳ
 Form1->ComboBox3->ItemIndex=0;
 Form1->ComboBox4->ItemIndex=0;     // ポストトリガ指定

 Form1->ComboBox5->ItemIndex=0;     // 周期指定モード

 Form1->ComboBox6->ItemIndex=0;     // 変換値はバイナリ表記

 Form1->ComboBox7->ItemIndex=0;     // 入力モードはシングル入力モード

 Form1->ComboBox8->ItemIndex=1;     // トリガ源は内部レベル（＋）

 Form1->ComboBox9->ItemIndex=23;    // 転送サイズは最大
 Form1->ComboBox10->ItemIndex=0;    // プリトリガバッファはなし

 Form1->ComboBox12->ItemIndex=0;    // ±１０２４Ｖ指定

 Form1->CheckBox2->Checked=1;       // スキャン０使用
 Form1->CheckBox3->Checked=1;       // スキャン１使用
 Form1->CheckBox4->Checked=1;       // スキャン２使用
 Form1->CheckBox5->Checked=1;       // スキャン３使用
 Form1->CheckBox6->Checked=1;       // スキャン４使用
 Form1->CheckBox7->Checked=1;       // スキャン５使用
 Form1->CheckBox8->Checked=1;       // スキャン６使用
 Form1->CheckBox9->Checked=1;       // スキャン７使用
 Form1->CheckBox10->Checked=1;      // スキャン８使用
 Form1->CheckBox11->Checked=1;      // スキャン９使用
 Form1->CheckBox12->Checked=1;      // スキャン10使用
 Form1->CheckBox13->Checked=1;      // スキャン11使用
 Form1->CheckBox14->Checked=1;      // スキャン12使用
 Form1->CheckBox15->Checked=1;      // スキャン13使用
 Form1->CheckBox16->Checked=1;      // スキャン14使用
 Form1->CheckBox17->Checked=1;      // スキャン15使用
 Form1->ComboBox13->ItemIndex=0;    // チャンネル０を接続

 Form1->ComboBox14->ItemIndex=1;    // チャンネル１を接続

 Form1->ComboBox15->ItemIndex=2;    // チャンネル２を接続

 Form1->ComboBox16->ItemIndex=3;    // チャンネル３を接続

 Form1->ComboBox17->ItemIndex=4;    // チャンネル４を接続

 Form1->ComboBox18->ItemIndex=5;    // チャンネル５を接続

 Form1->ComboBox19->ItemIndex=6;    // チャンネル６を接続

 Form1->ComboBox20->ItemIndex=7;    // チャンネル７を接続

 Form1->ComboBox21->ItemIndex=8;    // チャンネル８を接続

 Form1->ComboBox22->ItemIndex=9;    // チャンネル９を接続

 Form1->ComboBox23->ItemIndex=10;   // チャンネル10を接続

 Form1->ComboBox24->ItemIndex=11;   // チャンネル11を接続

 Form1->ComboBox25->ItemIndex=12;   // チャンネル12を接続

 Form1->ComboBox26->ItemIndex=13;   // チャンネル13を接続

 Form1->ComboBox27->ItemIndex=14;   // チャンネル14を接続

 Form1->ComboBox28->ItemIndex=15;   // チャンネル15を接続

 Form1->PageControl1->TabIndex=0;
 Form1->PageControl1->SetBounds(10,2,660,640);
 Form1->GroupBox1->BringToFront();
 Form1->GroupBox2->BringToFront();
 Form1->GroupBox3->BringToFront();
 Form1->Edit19->SetBounds(320,450,300,80);
 Form1->Edit19->BringToFront();
 Form1->Label30->SetBounds(320,430,300,16);
 Form1->Label30->BringToFront();
 Image1->Left = 10;
 Image1->Top = 10;
 Image1->Width = 630;
 Image1->Height = 400;
//Form1->GroupBox1->Refresh();
 //Form1->GroupBox1->Visible=True;
 //Form1->PageControl1->Constraints->MaxHeight=400;
 //Form1->PageControl1->TabWidth=400;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 int retc;
 int loop;
 TObject *tee;
 retc=Fcad416_Open_Driver( &num_board , &board_no[0]);

 if (retc == 0x0){
  Form1->Edit12->Text="Fcad416が見つかりました";
  Form1->Edit11->Text=IntToStr(num_board);
  Form1->ComboBox11->Clear();
  for (loop = 0 ; loop < num_board ; loop++)
   Form1->ComboBox11->Items->AddObject(IntToStr(board_no[loop]),tee);
  Form1->ComboBox11->ItemIndex=0;
 }
 else if(retc == -10)
  Form1->Edit12->Text="Fcad416が見つかりません";
 else if(retc == -11)
  Form1->Edit12->Text="Fcad416のロータリーＳＷが重複しています";
 else
  Form1->Edit12->Text="その他のエラーが発生しています";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
 int retc;
 int loop;
 // まず、すべてのボードをクローズする
 if (ringmode == 0){					// 有限サンプリング時の処理

  retc = Fcad416_Stop_Driver( );
  if(retc != 0 ){
   Form1->Edit12->Text="Fcad416_Stop_Driver 失敗";
   return;
  }
  else
   Form1->Edit12->Text="Fcad416_Stop_Driver 成功";
 }
 else{								// 無限サンプリング時の処理

  retc = Fcad416_Stop_Samp_Loop( );
  if(retc != 0){
   Form1->Edit12->Text="Stop samp fail";
   return;
  }
  else
   Form1->Edit12->Text="Stop samp success";
 }
 // 最後にドライバーもクローズして終了する

 retc = Fcad416_Close_Driver();
 if(retc != 0)
  Form1->Edit12->Text="Fcad416_Close_Driver 失敗";
 else{
  Form1->Edit12->Text="Fcad416_Close_Driver 成功";
  Form1->Button4->Caption="サンプリング";
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 int retc, loop;
 char string[10];
 if( (retc = Fcad416_Start_Driver( Handle )) != 0 ){
  Form1->Edit12->Text="Fcad416_Start_Driver 失敗";
  itoa(retc, string, 10);
  Form1->Edit6->Text=IntToStr(retc);
  return;
 }
 else
  Form1->Edit12->Text="Fcad416_Start_Driver 成功";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
 int    retc, loop;
// まずトリガ条件を決定する。対象はトリガソースと二つあるスレッショルド値
 switch(Form1->ComboBox8->ItemIndex){
        case 0:                             // 即トリガ
			Trigger_Source = 0;              // トリガ種類（エッジ、レベル、デュアルエッジ等）

            break;
        case 1:                             // アナログレベル＋

            Trigger_Source = 1;
			Trigger_Type = 3;
			break;
        case 2:                             // アナログレベル－

            Trigger_Source = 1;
            Trigger_Type = 2;
            break;
        case 3:                             // アナログエッジ＋

            Trigger_Source = 1;
            Trigger_Type = 1;
            break;
        case 4:                             // アナログエッジ－

            Trigger_Source = 1;
            Trigger_Type = 0;
            break;
        case 5:                             // アナログアウトレンジ
            Trigger_Source = 1;
			Trigger_Type = 4;
            break;
        case 6:                             // アナログインレンジ
            Trigger_Source = 1;
            Trigger_Type = 5;
            break;
        case 7:                             // デュアルスロープ＋

            Trigger_Source = 1;
            Trigger_Type = 7;
            break;
        case 8:                             // デュアルスロープ－

            Trigger_Source = 1;
            Trigger_Type = 6;
            break;
        case 9:                             // 外部エッジ＋

            Trigger_Source = 2;
            Trigger_Type = 1;
            break;
        case 10:                            // 外部エッジ－

            Trigger_Source = 2;
            Trigger_Type = 0;
        default:
            Trigger_Source = 0;
 }

Trigger_Mode = ComboBox4->ItemIndex;        // ポストトリガ、プリトリガ種別（有限／無限も）

Threshold2 = StrToInt(Edit9->Text);
Threshold1 = StrToInt(Edit10->Text);

/********************************************************/
/* 次はトリガモード、プリトリガバッファの状態をセンス   */
/********************************************************/
PriTriggerBuffer = ComboBox10->ItemIndex;
if ((Trigger_Mode == 1) & (PriTriggerBuffer == 0)) {
//	Form1->Edit12->Text="プリトリガでプリトリガバッファがない";
	ComboBox10->ItemIndex = 1;
	PriTriggerBuffer = ComboBox10->ItemIndex;
	//	return;
}
/********************************************************/
/* Fcad416_Set_Trigger関数を発行する                    */
/********************************************************/
retc = Fcad416_Set_Trigger(Trigger_Mode, Trigger_Source, Trigger_Type, Threshold1, Threshold2, StopEnable);
if (retc != 0)
 Form1->Edit12->Text="トリガ設定異常";

/********************************************/
/* 次はFcad416_Set_SampCh関数を発行する     */
/********************************************/
// サンプリングチャンネルの設定

scan_order[0] = ComboBox13->ItemIndex;
scan_order[1] = ComboBox14->ItemIndex;
scan_order[2] = ComboBox15->ItemIndex;
scan_order[3] = ComboBox16->ItemIndex;
scan_order[4] = ComboBox17->ItemIndex;
scan_order[5] = ComboBox18->ItemIndex;
scan_order[6] = ComboBox19->ItemIndex;
scan_order[7] = ComboBox20->ItemIndex;
scan_order[8] = ComboBox21->ItemIndex;
scan_order[9] = ComboBox22->ItemIndex;
scan_order[10] = ComboBox23->ItemIndex;
scan_order[11] = ComboBox24->ItemIndex;
scan_order[12] = ComboBox25->ItemIndex;
scan_order[13] = ComboBox26->ItemIndex;
scan_order[14] = ComboBox27->ItemIndex;
scan_order[15] = ComboBox28->ItemIndex;
scan_enable[0] = CheckBox2->Checked;
scan_enable[1] = CheckBox3->Checked;
scan_enable[2] = CheckBox4->Checked;
scan_enable[3] = CheckBox5->Checked;
scan_enable[4] = CheckBox6->Checked;
scan_enable[5] = CheckBox7->Checked;
scan_enable[6] = CheckBox8->Checked;
scan_enable[7] = CheckBox9->Checked;
scan_enable[8] = CheckBox10->Checked;
scan_enable[9] = CheckBox11->Checked;
scan_enable[10] = CheckBox12->Checked;
scan_enable[11] = CheckBox13->Checked;
scan_enable[12] = CheckBox14->Checked;
scan_enable[13] = CheckBox15->Checked;
scan_enable[14] = CheckBox16->Checked;
scan_enable[15] = CheckBox17->Checked;
Channel_Number = 0;
loop = 0;
while  ((scan_enable[loop] == 1) & (loop < 16)) {
 loop++;
 Channel_Number = Channel_Number + 1;
  }
no_ch = Channel_Number;
Input_Range = ComboBox12->ItemIndex;
for (loop = 0 ; loop < num_board; loop++)	// すべてのユニットに同じ設定を行う
 retc = Fcad416_Set_SampCh(board_no[loop], Channel_Number, scan_order, Input_Range);
if (retc!=0)
 return;
/************************************************/
/* 次は、Fcad416_Set_ScanSpeed関数を発行する    */
/************************************************/
if (ComboBox3->ItemIndex == 0)
 ScanSpeed = StrToInt(Edit2->Text);         // 単位がμＳだった

else
 ScanSpeed = StrToInt(Edit2->Text) * 1000;  // 単位がｍＳだった

/************************************************/
/* 次はFcad416_Set_Clock関数を発行する          */
/************************************************/
clk_source = ComboBox1->ItemIndex;
set_mode = ComboBox5->ItemIndex;
//Time_Unitの計算方法

//内部クロックの場合はスキャン周期×チャンネル数（周期）またはこれを内部クロック周期で割る(分周比）

//外部クロックの場合はExclk_Freqの逆数（周期）または分周比（セットされた値をそのまま使用）

if (clk_source < 2)                             // 内部クロックの場合

 if (set_mode == 0)                             // クロック周期設定の場合

  time_unit = (ScanSpeed * Channel_Number);     // 単位はμＳ
 else                                           // 分周比設定の場合

  if (clk_source == 0)                          // ２０ＭＨｚクロックだった場合

   time_unit = (ScanSpeed * Channel_Number) * 20;       // 数値をｎＳ換算してクロック周期（５０ｎＳ）で割る

  else                                          // １６．３８４ＭＨｚだった場合

   time_unit = int((ScanSpeed * Channel_Number) * 16.384);      // 数値をｎＳ換算してクロック周期（６１ｎＳ）で割る

else                                            // 外部クロックの場合

 if (set_mode == 0){                            // クロック周期設定の場合

  if(StrToInt(Edit3->Text) == NULL)
   return;
  time_unit = 1000000 / StrToInt(Edit3->Text);
}
 else{										   // 分周比設定の場合

  if(StrToInt(Edit4->Text) == NULL)
  return;
  time_unit = StrToInt(Edit4->Text);
}
clk_period = 2;                                 // 単位はμＳを使用
if ((clk_source > 1) & (set_mode == 0))       // 外部クロックで周期モード指定の場合

 exclk_freq = StrToInt(Edit3->Text);
else
 exclk_freq = 0;
retc = Fcad416_Set_Clock(clk_source, set_mode, time_unit, clk_period, exclk_freq);
if (retc != 0)
 Edit12->Text = "Set_Clock 失敗";
else
 Edit12->Text = "Set_Clock 成功";
retc = Fcad416_Set_ScanSpeed(ScanClockMode, ScanSpeed);
if(retc != 0)
 return;

/************************************************/
/* 次はFcad416_Set_InpMode関数を発行する        */
/************************************************/
Inp_mode = ComboBox7->ItemIndex;
Ad_code = ComboBox6->ItemIndex;
for (loop = 0 ; loop < num_board ; loop++){
 retc = Fcad416_Set_InpMode(board_no[loop], Inp_mode, Ad_code);
 if (retc != 0)
  Edit12->Text = "Set_InpMode 失敗";
 else
  Edit12->Text = "Set_InpMode 成功";
}
/************************************************/
/* 次はFcad416_Set_TransferSize関数を発行する   */
/************************************************/
Transer_Size = ComboBox9->ItemIndex;
retc = Fcad416_Set_TransferSize(Transer_Size);
if (retc != 0)
 Edit12->Text = "Set_TransferSize 失敗";
else
 Edit12->Text = "Set_TransferSize 成功";

/************************************************/
/* 次はFcad416_Set_Memory関数を発行する         */
/************************************************/
Mem_Size = ComboBox10->ItemIndex;
for (loop = 0 ; loop < num_board ; loop++){
 retc = Fcad416_Set_Memory(board_no[loop], Mem_Size);
 if (retc != 0)
  Edit12->Text = "Set_Memory 失敗";
 else
  Edit12->Text = "Set_Memory 成功";
}
/************************************************/
/* 次はFcad416_Set_SampLoop関数を発行する       */
/************************************************/
Ring_Mode = CheckBox1->Checked;
retc = Fcad416_Set_SampLoop(Ring_Mode);
if (retc != 0)
 Edit12->Text = "Set_SampLoop 失敗";
else
 Edit12->Text = "Set_Samploop 成功";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
 int loop;
 int retc;
 char string[10];
 post_samp = StrToInt(Edit5->Text);
 for (loop = 0 ; loop < num_board ; loop++){
  if ((1 == trg_mode) & (Memory_size[board_no[loop]] == 0)){
   Edit12->Text = "プリトリガバッファがない";
   return;
  }
 }
 if ((1 == trg_mode) & (trg_source == 0)){
  Edit12->Text = "即トリガでプリトリガは不可";
  return;
 }
 // サンプリングをスタートさせる
 if((retc = Fcad416_Start_Samp( post_samp)) != 0){
  Edit12->Text = "Sampling start fail";
  itoa( retc , string , 10);
  Edit6->Text = string;
  return;
 }
 else{
  Edit12->Text = "Sampling start success";
  InSamplingMode = 1;
  TestCount++;
  Edit13->Text = IntToStr(TestCount);
  if(ringmode == 1)
   Button4->Caption = "Samp Stop";
  else
   Button4->Caption = "In Sampling";
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Message_Get(TMessage &Message)
{
 int loop;
 TObject *sender;
 switch (Message.LParam){
  case 0:				// MSG_SAMP_END
   for (loop = 0 ; loop < num_board ; loop++)
    Fcad416_Clear_Flags( board_no[loop], 0xff );
   InSamplingMode = 0;
   Button10Click(sender);										// ステータスを取得する

   Edit12->Text = "指定サンプリング終了";
   Button4->Caption = "サンプリング";	// ボタン表示を元に戻す

   data_count += post_sampled;
   Button5Click(sender);				// 勝手にグラフ表示を行わせる
   Fcad416_Stop_Samp( );								// スタートビットのみを抑止する
   break;
  case 1:				// MSG_LOST_ERROR
   Fcad416_Stop_Samp( );
//		m_messagebox.SetWindowText( "エラーフラグ" );
   Button10Click(sender);		// エラーが発生したらステータスをチェックする
   Edit6->Text = IntToStr(data_count);
   Edit12->Text = "エラーフラグ";
   break;
  case 2:				// Cable removed check
   Edit12->Text = "USB Cable removed";
   break;
  case 3:				// MSG_TRIGGER
   Edit12->Text = "Trigger Detected";
   break;
  case 4:				// 転送バッファサイズデータ取得メッセージ
   Button10Click(sender);		// ステータスチェック
   Edit6->Text = IntToStr(data_count);
   break;
  case 5:				// リングバッファ一巡メッセージ
   Edit12->Text = "RingBuffer wrap round";
   break;
  case 6:				// サービスリクエスト受信メッセージ
   Edit12->Text = "Service Request Received";
//   Fcad416_Clear_ServiceReq( SelectedBoard );
   Fcad416_Clear_ServiceReq( board_no[0] );
   break;
 }
 Edit6->Text = IntToStr(data_count);
 return;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button10Click(TObject *Sender)
{
 return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PageControl1Change(TObject *Sender)
{
 if(PageControl1->TabIndex == 1){
  Form1->Image1->Top=200;
  Form1->Image1->Left=10;
  Image1->Canvas->Brush->Color = clWhite;
  Form1->Image1->Canvas->Rectangle(0,0,630,400);
  Form1->GroupBox2->Visible=false;
  Form1->GroupBox3->Visible=false;
  Form1->Label30->Visible=false;
  Form1->Edit19->Visible=false;
 }
 else{
  Form1->GroupBox2->Visible=true;
  Form1->GroupBox3->Visible=true;
  Form1->Label30->Visible=true;
  Form1->Edit19->Visible=true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
// サンプリングデータを画面表示するサブルーチン
{
 long hight,width,posx,posy,startx,starty;
 double pre_span, post_span;
 DWORD	datanum;
 int	chnum, retc;
 int	centervalue, widthvalue;
 int	lowend, highend, memcount, precount;
 int	high_threshold,low_threshold;
 int status[2];
 char	string[10];

 if (PageControl1->TabIndex == 0)
   return;
 else{
	centervalue = StrToInt(Edit7->Text);
	widthvalue = StrToInt(Edit8->Text);
	high_threshold = StrToInt(Edit9->Text);
	low_threshold = StrToInt(Edit10->Text);
	if (widthvalue == 0)
		widthvalue = 1;				// 0div 対策

	highend = centervalue + widthvalue;
	lowend = centervalue - widthvalue;
	Fcad416_Get_Status( board_no[0], &post_sampled, &pre_sampled, status);
	if(post_sampled == 0)
		post_sampled = 1;

	memcount = post_sampled * no_ch;								// まずポストトリガ分のデータを読み込む
	if(status[1] & 0x10)
		pre_sampled = ComboBox10->ItemIndex * 0x100000 / no_ch;	// ラップラウンドしているのでバッファ目一杯データがある


	disp_buffer = (LPWORD)malloc(( memcount + pre_sampled * no_ch) * 2 );	// バッファはプリトリガ分も一緒に確保

	Edit12->Text = IntToStr(no_ch);
	if(disp_buffer == NULL){
		MessageBox(NULL,NULL, "メモリ領域が不足しています。", MB_OK);
//		free( disp_buffer );
//		return;
	}
	// プリトリガ分後ろにずらしてポストトリガデータを読み込む
	if ((retc = Fcad416_Read_DllData( SelectedBoard, (memcount / no_ch), 0, (disp_buffer + (pre_sampled * no_ch)), memcount * 2)) != 0){
		Edit12->Text="ReadDllData fail";
		free( disp_buffer );
		disp_buffer = NULL;
		itoa(retc, string, 10);
		Edit6->Text = string;
		return;
	}
	else
		Edit12->Text="ReadDllData success";
	precount = pre_sampled * no_ch;
	if ( pre_sampled * no_ch > PriTrigBufSize){
		pre_position = pre_sampled - PriTrigBufSize / no_ch;
		pre_position = 0;
	}
	else
		pre_position = 0;
	if (precount > 0){
		if ((retc = Fcad416_Read_DirectRam( SelectedBoard, pre_sampled, pre_position, disp_buffer, DWORD(precount * 2))) != 0){
			Edit12->Text="Read pritrigger buffer failed";
			free( disp_buffer );
			disp_buffer = NULL;
			return;
		}
		else
			Edit12->Text= "Read pritrigger buffer success";
	}

	if(pre_sampled && (post_sampled > 1))
		pre_span = (double)(pre_sampled + post_sampled - 1) / pre_sampled;	// 画面幅に対するプリトリガデータ幅（逆数）

	else if(pre_sampled && (post_sampled == 1))
		pre_span = (double)(pre_sampled + post_sampled) / pre_sampled;
	else
		;
	if(post_sampled > 1)
		post_span = (double)(pre_sampled + post_sampled - 1) / (post_sampled - 1);	// 画面幅に対するポストトリガデータ幅

	else
		post_span = (double)(pre_sampled + post_sampled) / post_sampled;	// 画面幅に対するポストトリガデータ幅（逆数）

	// 描画エリアをクリアする
	Image1->Canvas->Brush->Color = clWhite;
	Image1->Canvas->Rectangle(0,0,630,400);
	posx = X_START;
	startx = posx;
	posy = Y_START;
	starty = posy;
	hight = Image1->ClientHeight;				// 描画エリアの高さ取得

	width = Image1->ClientWidth;				// 描画エリアの幅取得

	// Redで中心線を引く
	Image1->Canvas->Brush->Color = clSkyBlue;
	Image1->Canvas->MoveTo(0,hight / 2);
	Image1->Canvas->LineTo(width, hight / 2);
	if(pre_sampled > 0){
		Image1->Canvas->Rectangle(0, 0, (int)(width / pre_span), (int)hight);
		posx = startx + (long)(width / pre_span);
		posy = starty;
		Image1->Canvas->MoveTo(posx , posy);
		posy += hight - 1;
		Image1->Canvas->LineTo(posx , posy);
	}
	posx = startx;
	posy = starty + hight - (high_threshold * 256 - lowend) * hight / (highend - lowend);
	Image1->Canvas->MoveTo(posx,posy);
	posx += width - 1;
	Image1->Canvas->LineTo(posx,posy);
	posx = startx;
	posy=starty + hight - (low_threshold * 256 - lowend) * hight / (highend - lowend);
	Image1->Canvas->MoveTo(posx,posy);
	posx += width - 1;
	Image1->Canvas->LineTo(posx,posy);
	  for ( chnum = 0 ; chnum < no_ch ; chnum++){
		if(chnum == 0){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 1){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 2){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 3){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 4){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 5){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 6){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 7){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 8){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 9){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 10){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 11){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 12){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 13){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else if(chnum == 14){
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
		else {
		  if (pre_sampled > 0)						// プリトリガサンプリングの場合

			posy = starty + hight - (disp_buffer[chnum] - lowend) * hight / (highend - lowend);
		  else										// ポストトリガサンプリングの場合

			posy = starty + hight - (*(disp_buffer + chnum) - lowend) * hight / (highend - lowend);
		  if(posy >= starty + hight)
			posy = starty + hight - 1;
		  if(posy < starty)
			posy = starty;
		  posx = startx;								// 最初の点のための座標を計算する

		  Image1->Canvas->MoveTo(posx, posy);			// 最初の点を打つ
		  if (memcount / no_ch <2){					// データ数が１だったときの表示を行う
			Image1->Canvas->LineTo(posx + 20,posy);
			break;
		  }
		  else
			;
		  for (datanum = 1 ; datanum < (post_sampled + pre_sampled) ; datanum++){
			posx = (long)(width * datanum / (post_sampled + pre_sampled)) + startx;
			posy = starty + hight - (disp_buffer[chnum + datanum * no_ch] - lowend) * hight / (highend - lowend);
			if(posy >= starty + hight)
			  posy = starty + hight - 1;
			if(posy < starty)
			  posy = starty;
			if(posx >= (startx + width))
			  posx = startx + width - 1;
			Image1->Canvas->LineTo(posx, posy);
		  }
		}
	  }
	}
}
//---------------------------------------------------------------------------



